﻿Public Class frmMain

#Region " Declarations "
  Private _fileName As String
  Private _headerData() As Byte
  Private _is68kFile As Boolean
#End Region

#Region " Event Handlers "
  Private Sub frmMain_Load(ByVal sender As Object, ByVal e As EventArgs) _
      Handles Me.Load
    'Set the title
    _SetTitle()

    _Reset()
  End Sub

  Private Sub frmMain_NewClicked(ByVal sender As Object, ByVal e As EventArgs) _
      Handles tsmNew.Click, tsbNew.Click
    _Close()

    If Not trvMain.Visible Then
      _LoadCertificateData(Nothing)
    End If
  End Sub

  Private Sub tsmOpenBinaryFile_Click(ByVal sender As Object, ByVal e As EventArgs) _
      Handles tsmOpenBinaryFile.Click
    _Close()

    If Not trvMain.Visible Then
      Dim ofd As New OpenFileDialog

      ofd.CheckFileExists = True
      ofd.AddExtension = True
      ofd.DefaultExt = "bin"
      ofd.Filter = "Binary Files (*.bin)|*.bin|All Files (*.*)|*.*"
      ofd.Multiselect = False
      ofd.Title = "Select Binary File"

      If ofd.ShowDialog() = Windows.Forms.DialogResult.OK Then
        'Attempt to load the data into a Byte array
        Dim s As IO.Stream = ofd.OpenFile()
        Dim length As Integer = Convert.ToInt32(s.Length)
        Dim data(length - 1) As Byte

        s.Read(data, 0, length)
        s.Close()

        _fileName = ofd.FileName
        _LoadCertificateData(data)
      End If
    End If
  End Sub

  Private Sub tsmOpen8XQFile_Click(ByVal sender As Object, ByVal e As EventArgs) _
      Handles tsmOpen8XQFile.Click
    _Close()

    If Not trvMain.Visible Then
      Dim ofd As New OpenFileDialog

      ofd.CheckFileExists = True
      ofd.AddExtension = True
      ofd.DefaultExt = "8xq"
      ofd.Filter = "8XQ Files (*.8xq)|*.8xq|All Files (*.*)|*.*"
      ofd.Multiselect = False
      ofd.Title = "Select 8XQ Certificate File"

      If ofd.ShowDialog() = Windows.Forms.DialogResult.OK Then
        'Attempt to load the data into a Byte array
        Dim s As IO.Stream = ofd.OpenFile()
        Dim length As Integer = Convert.ToInt32(s.Length - &H4E)
        Dim data(length - 1) As Byte

        s.Seek(&H4E, IO.SeekOrigin.Begin)

        s.Read(data, 0, length)
        s.Close()

        _fileName = ofd.FileName
        _LoadCertificateData(data)
      End If
    End If
  End Sub

  Private Sub tsmOpen68kFile_Click(ByVal sender As Object, ByVal e As EventArgs) _
    Handles tsmOpen68kFile.Click
    _Close()

    If Not trvMain.Visible Then
      Dim ofd As New OpenFileDialog

      ofd.CheckFileExists = True
      ofd.AddExtension = True
      ofd.Filter = "All Files (*.*)|*.*"
      ofd.Multiselect = False
      ofd.Title = "Select TI-89/Ti/92 Plus/Voyage 200 Application/OS Upgrade"

      If ofd.ShowDialog() = Windows.Forms.DialogResult.OK Then
        'Attempt to load the data into a Byte array
        Dim s As IO.Stream = ofd.OpenFile()
        Dim length As Integer = Convert.ToInt32(s.Length - &H4E)
        Dim headerData(&H4A - 1) As Byte
        Dim data(length - 1) As Byte

        s.Read(headerData, 0, &H4A)
        _headerData = headerData
        s.Seek(&H4E, IO.SeekOrigin.Begin)
        s.Read(data, 0, length)
        s.Close()

        _fileName = ofd.FileName
        _LoadCertificateData(data)

        _is68kFile = True
      End If
    End If
  End Sub

  Private Sub tsmOpenCertificateDump_Click(ByVal sender As Object, ByVal e As EventArgs) _
      Handles tsmOpenCertificateDump.Click
    _Close()

    If Not trvMain.Visible Then
      Dim ofd As New OpenFileDialog

      ofd.CheckFileExists = True
      ofd.AddExtension = True
      ofd.DefaultExt = "8xv"
      ofd.Filter = "8XV Files (*.8xv)|*.8xv|All Files (*.*)|*.*"
      ofd.Multiselect = False
      ofd.Title = "Select AppVar Certificate Dump"

      If ofd.ShowDialog() = Windows.Forms.DialogResult.OK Then
        'Attempt to load the data into a Byte array
        Dim s As IO.Stream = ofd.OpenFile()

        s.Seek(&H37, IO.SeekOrigin.Begin)
        Dim length As Integer = s.ReadByte()
        length = length Or (s.ReadByte >> 8) + 2
        s.Seek(length, IO.SeekOrigin.Current)
        length = s.ReadByte()
        length = length Or (s.ReadByte << 8)
        Dim data(length - 1) As Byte

        s.Read(data, 0, length)
        s.Close()

        'Find the start of the certificate data
        Dim position As Integer
        If length > &H2000 Then
          'We have more than one sector of data here, figure out which it is
          If data(0) = &H2000 Then
            position = &H2000
          Else
            'It's at the beginning
          End If
        End If

        'Skip the sector valid byte
        position += 1

        'Create a new Byte array to represent an empty sector, and copy the certificate data to it
        Dim sector(&H2000 - 1) As Byte
        For i As Integer = 0 To sector.Length - 1
          sector(i) = &HFF
        Next
        Array.Copy(data, position, sector, 0, Math.Min(&H1FFF, data.Length - position))

        _fileName = ofd.FileName
        _LoadCertificateData(sector)
      End If
    End If
  End Sub

  Private Sub tsmRawCertificateDump_Click(ByVal sender As Object, ByVal e As EventArgs) _
      Handles tsmRawCertificateDump.Click
    _Close()

    If Not trvMain.Visible Then
      Dim ofd As New OpenFileDialog

      ofd.CheckFileExists = True
      ofd.AddExtension = True
      ofd.DefaultExt = "bin"
      ofd.Filter = "BIN Files (*.bin)|*.bin|All Files (*.*)|*.*"
      ofd.Multiselect = False
      ofd.Title = "Select Raw Certificate Dump"

      If ofd.ShowDialog() = Windows.Forms.DialogResult.OK Then
        'Attempt to load the data into a Byte array
        Dim s As IO.Stream = ofd.OpenFile()
        Dim length As Integer = Convert.ToInt32(s.Length)
        Dim data(length - 1) As Byte

        s.Read(data, 0, length)
        s.Close()

        'Find the start of the certificate data
        Dim position As Integer
        If length > &H2000 Then
          'We have more than one sector of data here, figure out which it is
          If data(0) = &H2000 Then
            position = &H2000
          Else
            'It's at the beginning
          End If
        End If

        'Skip the sector valid byte
        position += 1

        'Create a new Byte array to represent an empty sector, and copy the certificate data to it
        Dim sector(&H2000 - 1) As Byte
        For i As Integer = 0 To sector.Length - 1
          sector(i) = &HFF
        Next
        Array.Copy(data, position, sector, 0, Math.Min(&H1FFF, data.Length - position))

        _fileName = ofd.FileName
        _LoadCertificateData(sector)
      End If
    End If
  End Sub

  Private Sub frmMain_AddClicked(ByVal sender As Object, ByVal e As EventArgs) _
      Handles tsmAdd.Click, tsbAdd.Click
    Dim add As New frmEditField(New Field, True)

    If add.ShowDialog() = Windows.Forms.DialogResult.OK Then
      Dim node As New TreeNode

      node.Tag = add.Field
      node.Text = node.Tag.ToString()

      If trvMain.SelectedNode IsNot Nothing Then
        trvMain.SelectedNode.Nodes.Add(node)
        trvMain.SelectedNode.Expand()
      Else
        trvMain.Nodes(0).Nodes.Add(node)
        trvMain.Nodes(0).Expand()
      End If
    End If
  End Sub

  Private Sub trvMain_NodeMouseDoubleClick(ByVal sender As Object, ByVal e As TreeNodeMouseClickEventArgs) _
      Handles trvMain.NodeMouseDoubleClick
    frmMain_EditClicked(sender, EventArgs.Empty)
  End Sub

  Private Sub frmMain_EditClicked(ByVal sender As Object, ByVal e As EventArgs) _
      Handles tsmEdit.Click, tsbEdit.Click
    If trvMain.SelectedNode IsNot Nothing AndAlso trvMain.SelectedNode IsNot trvMain.Nodes(0) Then
      Dim edit As New frmEditField(DirectCast(trvMain.SelectedNode.Tag, Field), _
          trvMain.SelectedNode.Nodes.Count = 0)

      If edit.ShowDialog() = Windows.Forms.DialogResult.OK Then
        trvMain.SelectedNode.Tag = edit.Field
        trvMain.SelectedNode.Text = trvMain.SelectedNode.Tag.ToString()
      End If
    End If
  End Sub

  Private Sub frmMain_DeleteClicked(ByVal sender As Object, ByVal e As EventArgs) _
      Handles tsmDelete.Click, tsbDelete.Click
    If trvMain.SelectedNode IsNot Nothing AndAlso trvMain.SelectedNode IsNot trvMain.Nodes(0) Then
      trvMain.SelectedNode.Remove()
    End If
  End Sub

  Private Sub tsbExpand_Click(ByVal sender As Object, ByVal e As EventArgs) _
      Handles tsbExpand.Click
    If trvMain.SelectedNode IsNot Nothing AndAlso trvMain.SelectedNode IsNot trvMain.Nodes(0) Then
      _ExpandNode(trvMain.SelectedNode)
    End If
  End Sub

  Private Sub tsbCollapse_Click(ByVal sender As Object, ByVal e As EventArgs) _
      Handles tsbCollapse.Click
    If trvMain.SelectedNode IsNot Nothing AndAlso trvMain.SelectedNode IsNot trvMain.Nodes(0) Then
      _CollapseNode(trvMain.SelectedNode)
    End If
  End Sub

  Private Sub tsmMoveUp_Click(ByVal sender As Object, ByVal e As EventArgs) _
    Handles tsmMoveUp.Click
    Dim node As TreeNode = trvMain.SelectedNode

    If node IsNot Nothing AndAlso node IsNot trvMain.Nodes(0) Then
      Dim clone As TreeNode = Nothing
      Dim newIndex As Integer = node.Index - 1

      If newIndex <= node.Parent.Nodes.Count Then
        clone = DirectCast(node.Clone(), TreeNode)

        node.Parent.Nodes.Insert(newIndex, clone)
        node.Parent.Nodes.Remove(node)

        trvMain.SelectedNode = clone
      End If
    End If
  End Sub

  Private Sub tsmMoveDown_Click(ByVal sender As Object, ByVal e As EventArgs) _
      Handles tsmMoveDown.Click
    Dim node As TreeNode = trvMain.SelectedNode

    If node IsNot Nothing AndAlso node IsNot trvMain.Nodes(0) Then
      Dim clone As TreeNode = Nothing
      Dim newIndex As Integer = node.Index + 2

      If newIndex <= node.Parent.Nodes.Count Then
        clone = DirectCast(node.Clone(), TreeNode)

        node.Parent.Nodes.Insert(newIndex, clone)
        node.Parent.Nodes.Remove(node)

        trvMain.SelectedNode = clone
      End If
    End If
  End Sub

  Private Sub frmMain_SaveClicked(ByVal sender As Object, ByVal e As EventArgs) _
      Handles tsmSave.Click, tsbSave.Click
    _Save()
  End Sub

  Private Sub frmMain_SaveAsClicked(ByVal sender As Object, ByVal e As EventArgs) _
      Handles tsmSaveAs.Click
    _Save(True)
  End Sub

  Private Sub tsmClose_Click(ByVal sender As Object, ByVal e As EventArgs) _
      Handles tsmClose.Click
    _Close()
  End Sub

  Private Sub tsmAbout_Click(ByVal sender As Object, ByVal e As EventArgs) _
      Handles tsmAbout.Click
    _DisplayAbout()
  End Sub

  Private Sub tsbHelp_Click(ByVal sender As Object, ByVal e As EventArgs) _
      Handles tsbHelp.Click
    _DisplayAbout()
  End Sub

  Private Sub tsmExit_Click(ByVal sender As Object, ByVal e As EventArgs) _
    Handles tsmExit.Click
    Me.Close()
  End Sub
#End Region

#Region " Local Methods "
  Private Sub _DisplayAbout()
    MessageBox.Show(String.Format("{0} {1}{2}{2}{3}{2}{2}Feel free to do whatever you want with this program.", _
        My.Application.Info.AssemblyName, My.Application.Info.Version.ToString(3), Environment.NewLine, _
        My.Application.Info.CompanyName), My.Application.Info.AssemblyName, _
        MessageBoxButtons.OK, MessageBoxIcon.Information)
  End Sub

  Private Sub _Reset()
    _fileName = String.Empty
    _is68kFile = False

    trvMain.Visible = False
    trvMain.Nodes(0).Nodes.Clear()

    _SetControls()
  End Sub

  Private Sub _SetControls()
    Dim isNodeSelected As Boolean = trvMain.Visible

    tsmAdd.Enabled = isNodeSelected
    tsbAdd.Enabled = isNodeSelected
    tsmEdit.Enabled = isNodeSelected
    tsbEdit.Enabled = isNodeSelected
    tsmDelete.Enabled = isNodeSelected
    tsbDelete.Enabled = isNodeSelected
    tsbCollapse.Enabled = isNodeSelected
    tsbExpand.Enabled = isNodeSelected
    tsmMoveUp.Enabled = isNodeSelected
    tsmMoveDown.Enabled = isNodeSelected

    tsmSave.Enabled = trvMain.Visible
    tsbSave.Enabled = trvMain.Visible
    tsmSaveAs.Enabled = trvMain.Visible
    tsmClose.Enabled = trvMain.Visible

    _SetTitle()
  End Sub

  Private Sub _LoadCertificateData(ByVal data() As Byte)
    trvMain.Visible = True
    trvMain.Nodes(0).Nodes.Clear()

    If data IsNot Nothing Then
      Try
        'Load the data into our TreeView
        Dim i As Integer
        While i < data.Length - 1
          'Parse this field's ID and its data into a TreeNode
          Dim fieldId As Integer = (Convert.ToInt32(data(i)) << 8) Or data(i + 1)
          i += 2

          'If we're in FFFF land, get out
          If fieldId = &HFFFF Then Exit While

          Dim size As Integer = fieldId And &HF
          fieldId = fieldId And &HFFF0
          If size = &HD Then
            'Use the next byte as the size
            size = data(i)
            i += 1
          ElseIf size = &HE Then
            'Use the next word as the size
            size = (Convert.ToInt32(data(i)) << 8) Or data(i + 1)
            i += 2
          ElseIf size = &HF Then
            'Use the next dword as the size
            size = (Convert.ToInt32(data(i)) << 24) Or (Convert.ToInt32(data(i + 1)) << 16) Or _
                (Convert.ToInt32(data(i + 2)) << 8) Or data(i + 3)
            i += 4
          Else
            'The size is fine as it is
          End If

          'Get the data out
          Dim fieldData(size - 1) As Byte
          Array.Copy(data, i, fieldData, 0, size)
          i += size

          'Add this field to our TreeNode
          Dim node As New TreeNode
          Dim field As New Field(fieldId)
          field.Data = fieldData
          node.Tag = field
          node.Text = node.Tag.ToString()
          trvMain.Nodes(0).Nodes.Add(node)
        End While

        'Keep attempting to expand all children until we can't anymore
        Dim expanded As Boolean
        Do
          expanded = _ExpandAllNodes()
        Loop While expanded
      Catch ex As Exception
        MessageBox.Show("CertEdit cannot open this file. Check to make sure it is in the correct format.", _
            "Cannot Open File", MessageBoxButtons.OK, MessageBoxIcon.Error)

        trvMain.Visible = False
      End Try
    End If

    trvMain.Nodes(0).ExpandAll()
    _SetControls()
  End Sub

  Private Function _ExpandAllNodes() As Boolean
    Dim ret As Boolean

    For Each n As TreeNode In trvMain.Nodes(0).Nodes
      'ret = ret Or _ExpandNode(n)
    Next

    Return ret
  End Function

  Private Function _ExpandNode(ByVal node As TreeNode) As Boolean
    Dim ret As Boolean

    Try
      'Get this field's data
      Dim field As Field = DirectCast(node.Tag, Field)
      Dim data() As Byte = field.Data

      'Try to grab the field ID, size bytes (if any), and the data (as above)
      '  and add them as children to this node
      'Be sure to freak out if there's extra data not being placed into children
      If data.Length >= 2 Then
        Dim i As Integer
        While i < data.Length - 1
          'Parse this field's ID and its data into a TreeNode
          Dim fieldId As Integer = (Convert.ToInt32(data(i)) << 8) Or data(i + 1)
          i += 2

          Dim size As Integer = fieldId And &HF
          fieldId = fieldId And &HFFF0
          If size = &HD Then
            'Use the next byte as the size
            size = data(i)
            i += 1
          ElseIf size = &HE Then
            'Use the next word as the size
            size = (Convert.ToInt32(data(i)) << 8) Or data(i + 1)
            i += 2
          ElseIf size = &HF Then
            'Use the next dword as the size
            size = (Convert.ToInt32(data(i)) << 24) Or (Convert.ToInt32(data(i + 1)) << 16) Or _
                (Convert.ToInt32(data(i + 2)) << 8) Or data(i + 3)
            i += 4
          Else
            'The size is fine as it is
          End If

          'Get the data out
          Dim fieldData(size - 1) As Byte
          Array.Copy(data, i, fieldData, 0, size)
          i += size

          'Add this field to our TreeNode
          Dim n As New TreeNode
          Dim subField As New Field(fieldId)
          subField.Data = fieldData
          n.Tag = subField
          n.Text = n.Tag.ToString()
          node.Nodes.Add(n)

          ret = True
        End While

        field.Data = Nothing
        node.Text = node.Tag.ToString()
        node.ExpandAll()
      End If
    Catch ex As Exception
      ret = False
    End Try

    Return ret
  End Function

  Private Function _CollapseNode(ByVal node As TreeNode) As List(Of Byte)
    Dim field As Field = DirectCast(node.Tag, Field)
    Dim data As New List(Of Byte)

    'Build a Byte array containing all the children's data
    If node.Nodes.Count > 0 Then
      For Each n As TreeNode In node.Nodes
        data.AddRange(_CollapseNode(n))
      Next

      field.Data = data.ToArray()

      'Refresh this node
      node.Tag = field
      node.Text = node.Tag.ToString()

      'Remove children
      node.Nodes.Clear()
    Else
      'We're at a child node
      Dim fieldId As Integer = field.Id.Value
      Dim isShortLength As Boolean
      Dim isByteLength As Boolean
      Dim isWordLength As Boolean
      Dim isDWordLength As Boolean

      'Calculate the size of the data
      Dim size As Integer
      If field.Data IsNot Nothing Then size = field.Data.Length

      'Write the size, somehow
      If size < &HD Then
        fieldId = fieldId Or size

        isShortLength = True
      ElseIf size < &H100 Then
        fieldId = fieldId Or &HD

        isByteLength = True
      ElseIf size < &H10000 Then
        fieldId = fieldId Or &HE

        isWordLength = True
      Else
        fieldId = fieldId Or &HF

        isDWordLength = True
      End If

      'Write the field ID
      data.Add(Convert.ToByte((fieldId And &HFF00) >> 8))
      data.Add(Convert.ToByte(fieldId And &HFF))

      'Maybe write size bytes
      If isByteLength Then
        data.Add(Convert.ToByte(size))
      ElseIf isWordLength Then
        data.Add(Convert.ToByte((size And &HFF00) >> 8))
        data.Add(Convert.ToByte(size And &HFF))
      ElseIf isDWordLength Then
        data.Add(Convert.ToByte((size And &HFF000000) >> 24))
        data.Add(Convert.ToByte((size And &HFF0000) >> 16))
        data.Add(Convert.ToByte((size And &HFF00) >> 8))
        data.Add(Convert.ToByte(size And &HFF))
      Else
        'Write nothing
      End If

      'Return the data
      If field.Data IsNot Nothing Then
        For Each b As Byte In field.Data
          data.Add(b)
        Next
      End If
    End If

    Return data
  End Function

  Private Sub _SaveCertificateData(ByVal fileName As String)
    Dim extension As String = IO.Path.GetExtension(fileName).ToLower().Trim("."c)

    'Determine the file format to use
    Select Case True
      Case _is68kFile
        Dim file As New IO.FileStream(_fileName, IO.FileMode.Create)
        Dim data As New IO.MemoryStream

        file.Write(_headerData, 0, _headerData.Length)
        _SaveNodes(data, trvMain.Nodes(0).Nodes)
        Dim d(Convert.ToInt32(data.Length - 1)) As Byte
        data.Seek(0, IO.SeekOrigin.Begin)
        data.Read(d, 0, Convert.ToInt32(data.Length))
        data.Close()
        file.WriteByte(Convert.ToByte(d.Length And &HFF))
        file.WriteByte(Convert.ToByte((d.Length And &HFF00) >> 8))
        file.WriteByte(Convert.ToByte((d.Length And &HFF0000) >> 16))
        file.WriteByte(Convert.ToByte((d.Length And &HFF000000) >> 24))
        file.Write(d, 0, d.Length)

        file.Close()
      Case extension = "8xq"
        'Save to 8XQ certificate file
        Dim file As New CalcFileWriter(CalcFileWriter.CalcModel.TI8X, CalcFileWriter.VariableType.Certificate)
        Dim data As New IO.MemoryStream

        _SaveNodes(data, trvMain.Nodes(0).Nodes)
        Dim d(Convert.ToInt32(data.Length - 1)) As Byte
        data.Seek(0, IO.SeekOrigin.Begin)
        data.Read(d, 0, Convert.ToInt32(data.Length))
        data.Close()
        file.Data = d

        file.Save(fileName)
      Case extension = "8xv"
        'Save to 8XV AppVar certificate dump
        Dim file As New CalcFileWriter(CalcFileWriter.CalcModel.TI8X, CalcFileWriter.VariableType.AppVar)
        Dim data As New IO.MemoryStream
        Dim varData(&H4003 - 1) As Byte
        For i As Integer = 0 To varData.Length - 1
          varData(i) = &HFF
        Next
        varData(0) = &H0
        varData(1) = &H40
        varData(2) = &H0

        _SaveNodes(data, trvMain.Nodes(0).Nodes)
        Dim d(Convert.ToInt32(data.Length - 1)) As Byte
        data.Seek(0, IO.SeekOrigin.Begin)
        data.Read(d, 0, Convert.ToInt32(data.Length))
        data.Close()
        Array.Copy(d, 0, varData, 3, Math.Min(d.Length, &H4000))
        file.Data = varData

        file.Save(fileName)
      Case extension = "bin"
        _SaveToBinaryFile(fileName)
      Case extension = "txt"
        'Save to text file
        IO.File.WriteAllText(fileName, _GetCertData())
      Case Else
        _SaveToBinaryFile(fileName)
    End Select

    _fileName = fileName
  End Sub

  Private Sub _SaveToBinaryFile(ByVal fileName As String)
    Dim file As New IO.FileStream(fileName, IO.FileMode.Create)
    Dim data As New IO.MemoryStream

    _SaveNodes(data, trvMain.Nodes(0).Nodes)
    file.Write(data.GetBuffer(), 0, Convert.ToInt32(data.Position))

    file.Close()
  End Sub

  Private Sub _SaveNodes(ByRef file As IO.MemoryStream, ByVal nodes As TreeNodeCollection)
    For Each node As TreeNode In nodes
      Dim isShortLength As Boolean = False
      Dim isByteLength As Boolean = False
      Dim isWordLength As Boolean = False
      Dim isDWordLength As Boolean = False
      Dim field As Field = DirectCast(node.Tag, Field)
      Dim fieldId As Integer = field.Id.Value And &HFFF0

      If fieldId = &HFFF0 Then Exit For

      'Calculate the size of this parent node (ick!)
      Dim size As Integer = _GetNodeSize(node)

      'Write the size, somehow
      If size < &HD Then
        fieldId = fieldId Or size

        isShortLength = True
      ElseIf size < &H100 Then
        fieldId = fieldId Or &HD

        isByteLength = True
      ElseIf size < &H10000 Then
        fieldId = fieldId Or &HE

        isWordLength = True
      Else
        fieldId = fieldId Or &HF

        isDWordLength = True
      End If

      'Write the field ID
      file.WriteByte(Convert.ToByte((fieldId And &HFF00) >> 8))
      file.WriteByte(Convert.ToByte(fieldId And &HFF))

      'Maybe write size bytes
      If isByteLength Then
        file.WriteByte(Convert.ToByte(size))
      ElseIf isWordLength Then
        file.WriteByte(Convert.ToByte((size And &HFF00) >> 8))
        file.WriteByte(Convert.ToByte(size And &HFF))
      ElseIf isDWordLength Then
        file.WriteByte(Convert.ToByte((size And &HFF000000) >> 24))
        file.WriteByte(Convert.ToByte((size And &HFF0000) >> 16))
        file.WriteByte(Convert.ToByte((size And &HFF00) >> 8))
        file.WriteByte(Convert.ToByte(size And &HFF))
      Else
        'Write nothing
      End If

      If node.Nodes.Count > 0 Then
        'We have children, write them
        _SaveNodes(file, node.Nodes)
      Else
        'We don't have children, write the data from this field
        If field.Data IsNot Nothing Then
          For Each b As Byte In field.Data
            file.WriteByte(b)
          Next
        End If
      End If
    Next
  End Sub

  Private Function _GetNodeSize(ByVal node As TreeNode) As Integer
    Dim field As Field = DirectCast(node.Tag, Field)
    Dim ret As Integer

    If node.Nodes.Count > 0 Then
      'We have children, drill into their data
      For Each n As TreeNode In node.Nodes
        ret += _GetNodeSize(n)
      Next
    Else
      'No children, look at the data attached to the field itself
      If field.Data IsNot Nothing Then
        ret += field.Data.Length
      End If
    End If

    Return ret
  End Function

  Private Sub _Save()
    _Save(False)
  End Sub

  Private Sub _Save(ByVal saveAs As Boolean)
    'Save the data to a file
    If saveAs OrElse String.IsNullOrEmpty(_fileName) Then
      'We don't have a file name yet or we want a new one, so select one
      Dim sfd As New SaveFileDialog

      sfd.AddExtension = True
      sfd.Filter = String.Empty
      If Not _is68kFile Then
        sfd.Filter = "Binary File (*.bin)|*.bin|8XQ File (*.8xq)|*.8xq|Certificate Dump (*.8xv)|*.8xv|Text File (*.txt)|*.txt"
      End If
      sfd.Filter = (sfd.Filter & "|All Files (*.*)|*.*").Trim("|"c)
      sfd.Title = "Save Certificate Data"

      If sfd.ShowDialog = Windows.Forms.DialogResult.OK Then
        _fileName = sfd.FileName

        _SaveCertificateData(_fileName)
      End If
    Else
      'We have a file name and we just want to save it, so write it
      If MessageBox.Show("Are you SURE you want to save this file?", "Save File", MessageBoxButtons.YesNo, _
          MessageBoxIcon.Question) = Windows.Forms.DialogResult.Yes Then
        _SaveCertificateData(_fileName)
      End If
    End If
  End Sub

  Private Sub _Close()
    If trvMain.Visible Then
      Dim res As DialogResult = MessageBox.Show("Do you want to save your changes?", "Save Changes", _
          MessageBoxButtons.YesNoCancel, MessageBoxIcon.Question, MessageBoxDefaultButton.Button2)

      If res <> Windows.Forms.DialogResult.Cancel Then
        If res = Windows.Forms.DialogResult.Yes Then
          _Save()
        End If

        _Reset()
      Else
        'Nevermind, we're not really closing
      End If
    Else
      'We don't have anything open to edit, so we're good
    End If

    _SetControls()
  End Sub

  Private Function _GetCertData() As String
    Return _GetCertData(trvMain.Nodes(0).Nodes, 0)
  End Function

  Private Function _GetCertData(ByVal nodes As TreeNodeCollection, ByVal level As Integer) As String
    Dim ret As String = String.Empty

    For Each node As TreeNode In nodes
      Dim field As Field = DirectCast(node.Tag, Field)

      For i As Integer = 0 To level - 1
        ret &= ControlChars.Tab
      Next
      ret &= field.ToString(Integer.MaxValue) & Environment.NewLine

      If node.Nodes.Count > 0 Then
        ret &= _GetCertData(node.Nodes, level + 1)
      End If
    Next

    Return ret
  End Function

  Private Sub _SetTitle()
    Me.Text = My.Application.Info.AssemblyName & " " & My.Application.Info.Version.ToString(3)

    If Not String.IsNullOrEmpty(_fileName) Then
      Me.Text &= " - " & IO.Path.GetFileName(_fileName)
    End If
  End Sub
#End Region

End Class
